#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.2.12.1
 Author: Weber,Sascha
#ce ----------------------------------------------------------------------------

#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <CommMG.au3>;or if you save the commMg.dll in the @scripdir use #include @SciptDir & '\commmg.dll'
#Include <Date.au3>

;Konfiguration ...
;-----------------
;Schnittstelle:
Const $com_port = 1;4

;Sensor/Messwerte des Steuergerts:
Const $wbmsg_temp	= 2			;Khlwassertemperatur (ganze C)
Const $wbmsg_mVolts	= 12178		;Bordspannung in mV
Const $wbmsg_flame	= 0			;Flammberwachung
Const $wbmsg_Hpower	= 255
Const $wbmsg_glueR	= 482
Const $wbmsg_Status = 0

const $cmdchecktime=4

;Test:
Const $skipedFrames=0			;zum testen N empfangene Frames verwerfen
Global $blockBus=0				;auf die ersten N Bytes mit einem Break reagieren
;=========================================================================================
Global $outbuff[20], $inbuff[40], $MsComm, $cev, $framefull=0, $framelen=0, $m, $d, $ic, $skip=0, $Status=0, $update=0, $temp, $sFrame, $sportSetError
global $cmd1533_auto=-1,$cmdTele_auto=-1
Opt("GUIOnEventMode", 1)
Opt("MustDeclareVars",1)

#Region ### START Koda GUI section ### Form=D:\User-Data\Sascha\AutoIt\Webasto-SIM\Form1.kxf
Global $Form1 = GUICreate("Webasto-SIM", 530, 174, 192, 124)
GUISetOnEvent($GUI_EVENT_CLOSE, "Form1_Close")
Global $btn_s_Sm = GUICtrlCreateButton("Send Status Msg", 8, 8, 129, 25)
GUICtrlSetOnEvent(-1, "btn_s_Sm_Click")
Global $btn_s_1533_on = GUICtrlCreateButton("Send 1533 Heizen EIN", 8, 40, 129, 25)
GUICtrlSetOnEvent(-1, "btn_s_1533_on_Click")
Global $btn_s_1533_off = GUICtrlCreateButton("Send 1533 Heizen AUS", 8, 72, 129, 25)
GUICtrlSetOnEvent(-1, "btn_s_1533_off_Click")
Global $btn_skip_nf = GUICtrlCreateButton("Skip next Frame", 416, 8, 105, 25)
GUICtrlSetOnEvent(-1, "btn_skip_nf_Click")
Global $inp_status = GUICtrlCreateInput("", 256, 8, 41, 21)
Global $btn_setoff = GUICtrlCreateButton("Set Off", 304, 6, 49, 25)
GUICtrlSetOnEvent(-1, "btn_setoff_Click")
Global $btn_s_tele_on = GUICtrlCreateButton("Send Tele Heizen EIN", 8, 104, 129, 25)
GUICtrlSetOnEvent(-1, "btn_s_tele_on_Click")
Global $btn_s_tele_off = GUICtrlCreateButton("Send Tele Heizen AUS", 8, 136, 129, 25)
GUICtrlSetOnEvent(-1, "btn_s_tele_off_Click")
Global $Label1 = GUICtrlCreateLabel("Status", 216, 12, 34, 17)
Global $cb_cmd1533 = GUICtrlCreateCheckbox("Check Command", 152, 64, 97, 17)
Global $cb_cmdtele = GUICtrlCreateCheckbox("Check Command", 152, 120, 97, 17)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

_CommSetPort($com_port,$sportSetError,2400,8,2,1,2)
if $sportSetError <> '' then
   MsgBox(0,'Setport error = ',$sportSetError)
   GUIDelete($Form1)
   Exit
EndIf
_CommSetRTS(1)
_CommSetDTR(1)
ConsoleWrite("COM-Version: " & _CommGetVersion(1) & @crlf)
ConsoleWrite("Warte auf Daten ..." & @crlf)
$inbuff[0]=0
$sFrame=$skipedFrames

While 1
	$d=_CommReadByte()
	if $d<>"" Then
	   if $blockBus>0 Then
		  _CommSendBreak(70,70)
		  ConsoleWrite("Send Breake" & @CRLF)
		$framefull=0
		$inbuff[0]=0
		 $blockBus-=1
	  EndIf
;		ConsoleWrite("REC(" & hex($d,2) & ")")
		if $inbuff[0]<>0 or $d<>0 then
			$ic=$inbuff[0]+1
			$inbuff[0]=$ic
			$inbuff[$ic]=$d
			if $framelen >0 then
				$framelen-=1
				if $framelen=0 then
				   if $sFrame==0 Then
					   $framefull=$ic
   ;					ConsoleWrite("frame compete, Len=" & int($framefull) & "  :")
					   ConsoleWrite(_now() & " RX:")
					   $sFrame=$skipedFrames
					Else
					   $inbuff[0]=0
					   ConsoleWrite("Skip Frame" & @crlf)
					   $sFrame-=1
					 EndIf
				EndIf
			EndIf
			if $ic=2 then
				$framelen=$d
;				ConsoleWrite("new frame, Len=" & int($framelen) & " done ...")
			EndIf
		Else
			ConsoleWrite("detect W-Bus init" & @CRLF)
		EndIf
	EndIf
	Sleep(4)
	if $framefull>0 Then
		;Auswertung
		if $inbuff[1]<>0x42	Then	;alles auer Echo anzeigen
			for $m=1 to $inbuff[0]
				ConsoleWrite("0x" & hex($inbuff[$m],2) & " ")
			Next
			if $inbuff[1]<>0x24 then ConsoleWrite(@crlf & @crlf)
		Else
			ConsoleWrite("echo" & @crlf & @crlf)
		EndIf
		if $inbuff[1]=0x24 or $inbuff[1]=0x34 Then	;von Telestart oder 1533 an Heizung ?
			ConsoleWrite("****")
			Switch $inbuff[3]	;command
			case 0x21		;Heizen EIN
				ConsoleWrite("Heizen EIN, " & $inbuff[4] & "min" & @crlf)
				$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
				$outbuff[1]=0x03
				$outbuff[2]=0xA1
				$outbuff[3]=$inbuff[4]
				$status=0x21
				_MsgOut(4)

			case 0x22		;Lften EIN
				ConsoleWrite("Lften EIN, " & $inbuff[4] & "min" & @crlf)
				$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
				$outbuff[1]=0x03
				$outbuff[2]=0xA2
				$outbuff[3]=$inbuff[4]
				$status=0x22
				_MsgOut(4)

			case 0x10		;HEIZEN aus
				ConsoleWrite("Heizen AUS" & @crlf)
				$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
				$outbuff[1]=0x02
				$outbuff[2]=0x90
				$status=0x00
				_MsgOut(3)
				$cmd1533_auto=-1
				$cmdtele_auto=-1

			case 0x44		;check command
				ConsoleWrite("Check CMD 0x" & Hex($inbuff[4],2) & @crlf)
				$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
				$outbuff[1]=0x03
				$outbuff[2]=BitOR($inbuff[3],0x80)
				if $status=$inbuff[4] Then
					$outbuff[3]=0x00
				Else
					$outbuff[3]=0x01
				EndIf
				_MsgOut(4)

			case 0x50		;Query Data
				ConsoleWrite("Query DATA -->")
				Switch $inbuff[4]
				case 0x05	;Sensoren
					ConsoleWrite("Sensordaten lesen" & @crlf)
					$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
					$outbuff[1]=0x0B
					$outbuff[2]=0xD0
					$outbuff[3]=0x05
					$outbuff[4]=50 + $wbmsg_temp
					$outbuff[5]=BitShift(bitand($wbmsg_mVolts,0xFF00),8)
					$outbuff[6]=bitand($wbmsg_mVolts,0xFF)
					$outbuff[7]=$wbmsg_flame
					$outbuff[8]=BitShift(bitand($wbmsg_Hpower,0xFF00),8)
					$outbuff[9]=bitand($wbmsg_Hpower,0xFF)
					$outbuff[10]=BitShift(bitand($wbmsg_glueR,0xFF00),8)
					$outbuff[11]=bitand($wbmsg_glueR,0xFF)
					_MsgOut(12)
				case 0x03	;Status 1
					ConsoleWrite("Status lesen" & @crlf)
					$outbuff[0]=BitOR(BitShift(BitAND($inbuff[1],0xF0),4),0x40)
					$outbuff[1]=0x04
					$outbuff[2]=0xD0
					$outbuff[3]=0x03
					$outbuff[4]=$wbmsg_Status	;Flags
					_MsgOut(5)
				EndSwitch
			case Else
				ConsoleWrite("Unbekannter Frame" & @crlf)
			EndSwitch
			;ConsoleWrite(@crlf)
		EndIf

		$framefull=0
		$inbuff[0]=0
	EndIf
	if $update=0 Then
		GUICtrlSetData($inp_status,"0x" & Hex($status,2))
		$update=250
		if $cmd1533_auto>0 Then
		   $cmd1533_auto-=1
		   if not getCB($cb_cmd1533) then $cmd1533_auto=-1
		   if $cmd1533_auto=0 Then
			  $cmd1533_auto=$cmdchecktime
			 ConsoleWrite("Send Check CMD @1533" & @crlf)
			 $outbuff[0]=0x34
			 $outbuff[1]=0x04
			 $outbuff[2]=0x44
			 $outbuff[3]=0x21
			 $outbuff[4]=0x00
			 _MsgOut(5)
			EndIf
		 EndIf
		if $cmdtele_auto>0 Then
		   $cmdtele_auto-=1
		   if not getCB($cb_cmdtele) then $cmdtele_auto=-1
		   if $cmdtele_auto=0 Then
			  $cmdtele_auto=$cmdchecktime
			 ConsoleWrite("Send Check CMD @Telestart" & @crlf)
			 $outbuff[0]=0x24
			 $outbuff[1]=0x04
			 $outbuff[2]=0x44
			 $outbuff[3]=0x21
			 $outbuff[4]=0x00
			 _MsgOut(5)
			EndIf
		 EndIf

	Else
		$update-=1
	 EndIf
WEnd

Func Form1_Close()
	_Commcloseport()
	GUIDelete($Form1)
	Exit
EndFunc

Func btn_s_Sm_Click()
	ConsoleWrite("Send Check CMD Answer" & @crlf)
	$outbuff[0]=0x44
	$outbuff[1]=0x03
	$outbuff[2]=0xC4
	$outbuff[3]=0x00
	_MsgOut(4)
EndFunc
Func btn_s_1533_off_Click()
	ConsoleWrite("Send 1533 Heizen OFF" & @crlf)
	$outbuff[0]=0x34
	$outbuff[1]=0x02
	$outbuff[2]=0x10
	_MsgOut(3)
	$status=0
 EndFunc
 Func btn_s_tele_off_Click()
	ConsoleWrite("Send Telestart Heizen OFF" & @crlf)
	$outbuff[0]=0x24
	$outbuff[1]=0x02
	$outbuff[2]=0x10
	_MsgOut(3)
	$status=0
EndFunc
Func btn_s_1533_on_Click()
	ConsoleWrite("Send 1533 Heizen ON" & @crlf)
	$outbuff[0]=0x34
	$outbuff[1]=0x03
	$outbuff[2]=0x21
	$outbuff[3]=0x1E
	_MsgOut(4)
	$status=0x21
	if getCB($cb_cmd1533) then	$cmd1533_auto=$cmdchecktime
	$cmdtele_auto=-1
EndFunc
Func btn_s_tele_on_Click()
	ConsoleWrite("Send Telestart Heizen ON" & @crlf)
	$outbuff[0]=0x24
	$outbuff[1]=0x03
	$outbuff[2]=0x21
	$outbuff[3]=0x1E
	_MsgOut(4)
	$status=0x21
	if getCB($cb_cmdtele) then	$cmdtele_auto=$cmdchecktime
	$cmd1533_auto=-1
EndFunc

Func btn_skip_nf_Click()
	ConsoleWrite("Skip aktiv" & @CRLF)
	$skip=1
EndFunc
Func btn_setoff_Click()
	$status=0
EndFunc

Func _MsgOut($len)
	if $skip=0 Then
		Local $i,$cs=0,$ob[1]
	;	Sleep(300)
		ConsoleWrite(_now() & " TX:")
			for $i=1 to $len
				$cs=BitXOR($cs,$outbuff[$i-1])
				_CommSendByte($outbuff[$i-1])
				ConsoleWrite("0x" & hex($outbuff[$i-1],2) & " ")
			Next
			$ob[0]=$cs
	;		Sleep(300)
			_CommSendByte($cs)
			ConsoleWrite("0x" & hex($cs,2) & @crlf)
	EndIf
	$skip=0
EndFunc

Func getCB($cb)		;Checkbox- oder Radiobuttonzustand abfragen
	if BitAND(GUICtrlRead($cb),$GUI_CHECKED)>0 then Return True
	Return False
 EndFunc
